diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/ap-wifi-mac.cc ns-3.39/src/wifi/model/ap-wifi-mac.cc
--- ns-3.38/src/wifi/model/ap-wifi-mac.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/ap-wifi-mac.cc	2023-07-05 14:23:48.109428400 -0700
@@ -1932,6 +2044,146 @@
 }
 
 void
+ApWifiMac::ReceiveEmlNotification(MgtEmlOperatingModeNotification& frame,
+                                  const Mac48Address& sender,
+                                  uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << frame << sender << linkId);
+
+    auto ehtConfiguration = GetEhtConfiguration();
+
+    if (BooleanValue emlsrActivated;
+        !ehtConfiguration ||
+        !ehtConfiguration->GetAttributeFailSafe("EmlsrActivated", emlsrActivated) ||
+        !emlsrActivated.Get())
+    {
+        NS_LOG_DEBUG(
+            "Received an EML Operating Mode Notification frame but EMLSR is not activated");
+        return;
+    }
+
+    if (frame.m_emlControl.emlsrParamUpdateCtrl)
+    {
+        NS_ASSERT(frame.m_emlsrParamUpdate);
+        auto emlCapabilities =
+            GetWifiRemoteStationManager(linkId)->GetStationEmlCapabilities(sender);
+        NS_ASSERT_MSG(emlCapabilities, "EML Capabilities not stored for STA " << sender);
+
+        // update values stored in remote station manager
+        emlCapabilities->emlsrPaddingDelay = frame.m_emlsrParamUpdate->paddingDelay;
+        emlCapabilities->emlsrTransitionDelay = frame.m_emlsrParamUpdate->transitionDelay;
+    }
+
+    auto mldAddress = GetWifiRemoteStationManager(linkId)->GetMldAddress(sender);
+    NS_ASSERT_MSG(mldAddress, "No MLD address stored for STA " << sender);
+    auto emlsrLinks =
+        frame.m_emlControl.emlsrMode == 1 ? frame.GetLinkBitmap() : std::list<uint8_t>{};
+
+    // The AP MLD has to consider the changes carried by the received EML Notification frame
+    // as effective at the same time as the non-AP MLD. Therefore, we need to start a time
+    // when the transmission of the Ack following the received EML Notification frame is
+    // completed. For this purpose, we connect a callback to the PHY TX begin trace to catch
+    // the Ack transmitted after the EML Notification frame.
+    CallbackBase cb = Callback<void, WifiConstPsduMap, WifiTxVector, double>(
+        [=](WifiConstPsduMap psduMap, WifiTxVector txVector, double /* txPowerW */) {
+            NS_ASSERT_MSG(psduMap.size() == 1 && psduMap.begin()->second->GetNMpdus() == 1 &&
+                              psduMap.begin()->second->GetHeader(0).IsAck(),
+                          "Expected a Normal Ack after EML Notification frame");
+
+            auto ackDuration =
+                WifiPhy::CalculateTxDuration(psduMap, txVector, GetLink(linkId).phy->GetPhyBand());
+
+            TimeValue transitionTimeout;
+            ehtConfiguration->GetAttribute("TransitionTimeout", transitionTimeout);
+
+            m_transitionTimeoutEvents[sender] =
+                Simulator::Schedule(ackDuration + transitionTimeout.Get(), [=]() {
+                    for (uint8_t id = 0; id < GetNLinks(); id++)
+                    {
+                        auto linkAddress =
+                            GetWifiRemoteStationManager(id)->GetAffiliatedStaAddress(*mldAddress);
+                        if (!linkAddress)
+                        {
+                            // this link has not been setup by the non-AP MLD
+                            continue;
+                        }
+
+                        if (!emlsrLinks.empty())
+                        {
+                            // the non-AP MLD is enabling EMLSR mode
+                            /**
+                             * After the successful transmission of the EML Operating Mode
+                             * Notification frame by the non-AP STA affiliated with the non-AP MLD,
+                             * the non-AP MLD shall operate in the EMLSR mode and the other non-AP
+                             * STAs operating on the corresponding EMLSR links shall transition to
+                             * active mode after the transition delay indicated in the Transition
+                             * Timeout subfield in the EML Capabilities subfield of the Basic
+                             * Multi-Link element or immediately after receiving an EML Operating
+                             * Mode Notification frame from one of the APs operating on the EMLSR
+                             * links and affiliated with the AP MLD (Sec. 35.3.17 of 802.11be D3.0)
+                             */
+                            auto enabled = std::find(emlsrLinks.cbegin(), emlsrLinks.cend(), id) !=
+                                           emlsrLinks.cend();
+                            if (enabled)
+                            {
+                                StaSwitchingToActiveModeOrDeassociated(*linkAddress, id);
+                            }
+                            GetWifiRemoteStationManager(id)->SetEmlsrEnabled(*linkAddress, enabled);
+                        }
+                        else
+                        {
+                            // the non-AP MLD is disabling EMLSR mode
+                            /**
+                             * After the successful transmission of the EML Operating Mode
+                             * Notification frame by the non-AP STA affiliated with the non-AP MLD,
+                             * the non-AP MLD shall disable the EMLSR mode and the other non-AP
+                             * STAs operating on the corresponding EMLSR links shall transition to
+                             * power save mode after the transition delay indicated in the
+                             * Transition Timeout subfield in the EML Capabilities subfield of the
+                             * Basic Multi-Link element or immediately after receiving an EML
+                             * Operating Mode Notification frame from one of the APs operating on
+                             * the EMLSR links and affiliated with the AP MLD. (Sec. 35.3.17 of
+                             * 802.11be D3.0)
+                             */
+                            if (id != linkId &&
+                                GetWifiRemoteStationManager(id)->GetEmlsrEnabled(*linkAddress))
+                            {
+                                StaSwitchingToPsMode(*linkAddress, id);
+                            }
+                            GetWifiRemoteStationManager(id)->SetEmlsrEnabled(*linkAddress, false);
+                        }
+                    }
+                });
+        });
+
+    // connect the callback to the PHY TX begin trace to catch the Ack and disconnect
+    // after its transmission begins
+    auto phy = GetLink(linkId).phy;
+    phy->TraceConnectWithoutContext("PhyTxPsduBegin", cb);
+    Simulator::Schedule(phy->GetSifs() + NanoSeconds(1),
+                        [=]() { phy->TraceDisconnectWithoutContext("PhyTxPsduBegin", cb); });
+
+    // An AP MLD with dot11EHTEMLSROptionActivated equal to true sets the EMLSR Mode subfield
+    // to the value obtained from the EMLSR Mode subfield of the received EML Operating Mode
+    // Notification frame. (Sec. 9.6.35.8 of 802.11be D3.0)
+
+    // When included in a frame sent by an AP affiliated with an AP MLD, the EMLSR Parameter
+    // Update Control subfield is set to 0. (Sec. 9.6.35.8 of 802.11be D3.0)
+    frame.m_emlControl.emlsrParamUpdateCtrl = 0;
+
+    // An AP MLD with dot11EHTEMLSROptionImplemented equal to true sets the EMLSR Link Bitmap
+    // subfield to the value obtained from the EMLSR Link Bitmap subfield of the received
+    // EML Operating Mode Notification frame. (Sec. 9.6.35.8 of 802.11be D3.0)
+
+    // The EMLSR Parameter Update field [..] is present if [..] the Action frame is sent by
+    // a non-AP STA affiliated with a non-AP MLD (Sec. 9.6.35.8 of 802.11be D3.0)
+    frame.m_emlsrParamUpdate.reset();
+
+    auto ehtFem = StaticCast<EhtFrameExchangeManager>(GetFrameExchangeManager(linkId));
+    ehtFem->SendEmlOperatingModeNotification(sender, frame);
+}
+
+void
 ApWifiMac::DeaggregateAmsduAndForward(Ptr<const WifiMpdu> mpdu)
 {
     NS_LOG_FUNCTION(this << *mpdu);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/ap-wifi-mac.h ns-3.39/src/wifi/model/ap-wifi-mac.h
--- ns-3.38/src/wifi/model/ap-wifi-mac.h	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/ap-wifi-mac.h	2023-07-05 14:23:48.109428400 -0700
@@ -31,7 +31,7 @@
 namespace ns3
 {
 
-class SupportedRates;
+struct AllSupportedRates;
 class CapabilityInformation;
 class DsssParameterSet;
 class ErpInformation;
@@ -48,6 +48,7 @@
 class MgtAssocRequestHeader;
 class MgtReassocRequestHeader;
 class MgtAssocResponseHeader;
+class MgtEmlOperatingModeNotification;
 
 /// variant holding a  reference to a (Re)Association Request
 using AssocReqRefVariant = std::variant<std::reference_wrapper<MgtAssocRequestHeader>,
@@ -238,6 +239,18 @@
     void ParseReportedStaInfo(const AssocReqRefVariant& assoc, Mac48Address from, uint8_t linkId);
 
     /**
+     * Take necessary actions upon receiving the given EML Operating Mode Notification frame
+     * from the given station on the given link.
+     *
+     * \param frame the received EML Operating Mode Notification frame
+     * \param sender the MAC address of the sender of the frame
+     * \param linkId the ID of the link over which the frame was received
+     */
+    void ReceiveEmlNotification(MgtEmlOperatingModeNotification& frame,
+                                const Mac48Address& sender,
+                                uint8_t linkId);
+
+    /**
      * The packet we sent was successfully received by the receiver
      * (i.e. we received an Ack from the receiver).  If the packet
      * was an association response to the receiver, we record that
@@ -329,18 +342,6 @@
                                          const Mac48Address& to,
                                          uint8_t linkId);
     /**
-     * Configure the queue scheduler so that frames stored in the container queues associated
-     * with the station which we are sending an Association Response frame to are only transmitted
-     * on the setup links.
-     *
-     * \param linkIdStaAddrMap a map of (link ID, remote STA address) of the links to setup
-     * \param to the Receiver Address (RA) of the Association Response frame
-     * \param linkId the ID of the link on which the Association Response frame is being sent
-     */
-    void ConfigQueueScheduler(const LinkIdStaAddrMap& linkIdStaAddrMap,
-                              const Mac48Address& to,
-                              uint8_t linkId);
-    /**
      * Forward an association or a reassociation response packet to the DCF/EDCA.
      *
      * \param to the address of the STA we are sending an association response to
@@ -357,6 +358,31 @@
     void SendOneBeacon(uint8_t linkId);
 
     /**
+     * Process the Power Management bit in the Frame Control field of an MPDU
+     * successfully received on the given link.
+     *
+     * \param mpdu the successfully received MPDU
+     * \param linkId the ID of the given link
+     */
+    void ProcessPowerManagementFlag(Ptr<const WifiMpdu> mpdu, uint8_t linkId);
+    /**
+     * Perform the necessary actions when a given station switches from active mode
+     * to powersave mode.
+     *
+     * \param staAddr the MAC address of the given station
+     * \param linkId the ID of the link on which the given station is operating
+     */
+    void StaSwitchingToPsMode(const Mac48Address& staAddr, uint8_t linkId);
+    /**
+     * Perform the necessary actions when a given station deassociates or switches
+     * from powersave mode to active mode.
+     *
+     * \param staAddr the MAC address of the given station
+     * \param linkId the ID of the link on which the given station is operating
+     */
+    void StaSwitchingToActiveModeOrDeassociated(const Mac48Address& staAddr, uint8_t linkId);
+
+    /**
      * Return the Capability information of the current AP for the given link.
      *
      * \param linkId the ID of the given link
@@ -438,7 +464,7 @@
      * \param linkId the ID of the given link
      * \return all rates that we support
      */
-    SupportedRates GetSupportedRates(uint8_t linkId) const;
+    AllSupportedRates GetSupportedRates(uint8_t linkId) const;
     /**
      * Return the DSSS Parameter Set that we support on the given link
      *
@@ -501,6 +527,8 @@
     bool m_enableNonErpProtection; //!< Flag whether protection mechanism is used or not when
                                    //!< non-ERP STAs are present within the BSS
     Time m_bsrLifetime;            //!< Lifetime of Buffer Status Reports
+    /// transition timeout events running for EMLSR clients
+    std::map<Mac48Address, EventId> m_transitionTimeoutEvents;
 
     /// store value and timestamp for each Buffer Status Report
     struct BsrType
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/block-ack-manager.cc ns-3.39/src/wifi/model/block-ack-manager.cc
--- ns-3.38/src/wifi/model/block-ack-manager.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/block-ack-manager.cc	2023-07-05 14:23:48.109428400 -0700
@@ -600,8 +600,6 @@
     // schedule a BlockAckRequest
     NS_LOG_DEBUG("Schedule a Block Ack Request for agreement (" << recipient << ", " << +tid
                                                                 << ")");
-    Ptr<Packet> bar = Create<Packet>();
-    bar->AddHeader(GetBlockAckReqHeader(recipient, tid));
 
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_CTL_BACKREQ);
@@ -612,7 +610,7 @@
     hdr.SetNoRetry();
     hdr.SetNoMoreFragments();
 
-    ScheduleBar(Create<WifiMpdu>(bar, hdr));
+    ScheduleBar(GetBlockAckReqHeader(recipient, tid), hdr);
 }
 
 void
@@ -660,28 +658,27 @@
 }
 
 void
-BlockAckManager::ScheduleBar(Ptr<WifiMpdu> bar)
+BlockAckManager::ScheduleBar(const CtrlBAckRequestHeader& reqHdr, const WifiMacHeader& hdr)
 {
-    NS_LOG_FUNCTION(this << *bar);
-    NS_ASSERT(bar->GetHeader().IsBlockAckReq());
+    NS_LOG_FUNCTION(this << reqHdr << hdr);
 
-    CtrlBAckRequestHeader reqHdr;
-    bar->GetPacket()->PeekHeader(reqHdr);
     uint8_t tid = reqHdr.GetTidInfo();
 
-    WifiContainerQueueId queueId(WIFI_CTL_QUEUE, bar->GetHeader().GetAddr2(), std::nullopt);
+    WifiContainerQueueId queueId(WIFI_CTL_QUEUE, WIFI_UNICAST, hdr.GetAddr1(), std::nullopt);
+    auto pkt = Create<Packet>();
+    pkt->AddHeader(reqHdr);
     Ptr<WifiMpdu> item = nullptr;
 
     // if a BAR for the given agreement is present, replace it with the new one
     while ((item = m_queue->PeekByQueueId(queueId, item)))
     {
-        if (item->GetHeader().IsBlockAckReq() &&
-            item->GetHeader().GetAddr1() == bar->GetHeader().GetAddr1())
+        if (item->GetHeader().IsBlockAckReq() && item->GetHeader().GetAddr1() == hdr.GetAddr1())
         {
             CtrlBAckRequestHeader otherHdr;
             item->GetPacket()->PeekHeader(otherHdr);
             if (otherHdr.GetTidInfo() == tid)
             {
+                auto bar = Create<WifiMpdu>(pkt, hdr, item->GetTimestamp());
                 // replace item with bar
                 m_queue->Replace(item, bar);
                 return;
@@ -689,7 +686,7 @@
         }
     }
 
-    m_queue->Enqueue(bar);
+    m_queue->Enqueue(Create<WifiMpdu>(pkt, hdr));
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/block-ack-manager.h ns-3.39/src/wifi/model/block-ack-manager.h
--- ns-3.38/src/wifi/model/block-ack-manager.h	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/block-ack-manager.h	2023-07-05 14:23:48.109428400 -0700
@@ -32,6 +32,7 @@
 #include "ns3/traced-callback.h"
 
 #include <map>
+#include <optional>
 
 namespace ns3
 {
@@ -408,18 +409,19 @@
     CtrlBAckRequestHeader GetBlockAckReqHeader(const Mac48Address& recipient, uint8_t tid) const;
 
     /**
-     * \param bar the BlockAckRequest to enqueue
+     * \param reqHdr the BlockAckRequest header
+     * \param hdr the 802.11 MAC header
      *
-     * Enqueue the given BlockAckRequest into the queue storing the next (MU-)BAR
+     * Enqueue the given BlockAckRequest into the queue storing the next BAR
      * frames to transmit. If a BAR for the same recipient and TID is already present
      * in the queue, it is replaced by the new one. If the given BAR is retransmitted,
      * it is placed at the head of the queue, otherwise at the tail.
      */
-    void ScheduleBar(Ptr<WifiMpdu> bar);
+    void ScheduleBar(const CtrlBAckRequestHeader& reqHdr, const WifiMacHeader& hdr);
     /**
      * \param muBar the MU-BAR Trigger Frame to enqueue
      *
-     * Enqueue the given MU-BAR Trigger Frame into the queue storing the next (MU-)BAR
+     * Enqueue the given MU-BAR Trigger Frame into the queue storing the next MU-BAR
      * frames to transmit. If the given MU-BAR Trigger Frame is retransmitted,
      * it is placed at the head of the queue, otherwise at the tail.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/block-ack-type.h ns-3.39/src/wifi/model/block-ack-type.h
--- ns-3.38/src/wifi/model/block-ack-type.h	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/block-ack-type.h	2023-07-05 14:23:48.109428400 -0700
@@ -20,6 +20,7 @@
 #ifndef BLOCK_ACK_TYPE_H
 #define BLOCK_ACK_TYPE_H
 
+#include <cstdint>
 #include <ostream>
 #include <vector>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/channel-access-manager.cc ns-3.39/src/wifi/model/channel-access-manager.cc
--- ns-3.38/src/wifi/model/channel-access-manager.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/channel-access-manager.cc	2023-07-05 14:23:48.109428400 -0700
@@ -140,6 +140,13 @@
 }
 
 void
+ChannelAccessManager::DoInitialize()
+{
+    NS_LOG_FUNCTION(this);
+    InitLastBusyStructs();
+}
+
+void
 ChannelAccessManager::DoDispose()
 {
     NS_LOG_FUNCTION(this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/channel-access-manager.h ns-3.39/src/wifi/model/channel-access-manager.h
--- ns-3.38/src/wifi/model/channel-access-manager.h	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/channel-access-manager.h	2023-07-05 14:23:48.109428400 -0700
@@ -261,6 +261,7 @@
     bool IsBusy() const;
 
   protected:
+    void DoInitialize() override;
     void DoDispose() override;
 
   private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/ctrl-headers.cc ns-3.39/src/wifi/model/ctrl-headers.cc
--- ns-3.38/src/wifi/model/ctrl-headers.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/ctrl-headers.cc	2023-07-05 14:23:48.109428400 -0700
@@ -458,10 +458,12 @@
 
     for (auto& bitmapLen : m_baType.m_bitmapLen)
     {
-        m_baInfo.push_back({.m_aidTidInfo = 0,
-                            .m_startingSeq = 0,
-                            .m_bitmap = std::vector<uint8_t>(bitmapLen, 0),
-                            .m_ra = Mac48Address()});
+        BaInfoInstance baInfoInstance{.m_aidTidInfo = 0,
+                                      .m_startingSeq = 0,
+                                      .m_bitmap = std::vector<uint8_t>(bitmapLen, 0),
+                                      .m_ra = Mac48Address()};
+
+        m_baInfo.emplace_back(baInfoInstance);
     }
 }
 
@@ -1630,7 +1632,8 @@
       m_ulBandwidth(0),
       m_giAndLtfType(0),
       m_apTxPower(0),
-      m_ulSpatialReuse(0)
+      m_ulSpatialReuse(0),
+      m_padding(0)
 {
 }
 
@@ -1697,6 +1700,7 @@
     m_giAndLtfType = trigger.m_giAndLtfType;
     m_apTxPower = trigger.m_apTxPower;
     m_ulSpatialReuse = trigger.m_ulSpatialReuse;
+    m_padding = trigger.m_padding;
     m_userInfoFields.clear();
     m_userInfoFields = trigger.m_userInfoFields;
     return *this;
@@ -1761,7 +1765,7 @@
         size += ui.GetSerializedSize();
     }
 
-    size += 2; // Padding field
+    size += m_padding;
 
     return size;
 }
@@ -1800,7 +1804,10 @@
         i = ui.Serialize(i);
     }
 
-    i.WriteHtolsbU16(0xffff); // Padding field, used as delimiter
+    for (std::size_t count = 0; count < m_padding; count++)
+    {
+        i.WriteU8(0xff); // Padding field
+    }
 }
 
 uint32_t
@@ -1821,6 +1828,7 @@
     uint8_t bit54and55 = (commonInfo >> 54) & 0x03;
     m_variant = bit54and55 == 3 ? TriggerFrameVariant::HE : TriggerFrameVariant::EHT;
     m_userInfoFields.clear();
+    m_padding = 0;
 
     NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::BFRP_TRIGGER,
                     "BFRP Trigger frame is not supported");
@@ -1829,15 +1837,12 @@
     NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::NFRP_TRIGGER,
                     "NFRP Trigger frame is not supported");
 
-    bool isPadding = false;
-
-    // We always add a Padding field (of two octets of all 1s) as delimiter
-    while (!isPadding)
+    while (i.GetRemainingSize() >= 2)
     {
         // read the first 2 bytes to check if we encountered the Padding field
         if (i.ReadU16() == 0xffff)
         {
-            isPadding = true;
+            m_padding = i.GetRemainingSize() + 2;
         }
         else
         {
@@ -1874,8 +1879,7 @@
 {
 #define FOO(x)                                                                                     \
     case TriggerFrameType::x:                                                                      \
-        return #x;                                                                                 \
-        break;
+        return #x;
 
     switch (type)
     {
@@ -2112,6 +2116,19 @@
     return m_ulSpatialReuse;
 }
 
+void
+CtrlTriggerHeader::SetPaddingSize(std::size_t size)
+{
+    NS_ABORT_MSG_IF(size == 1, "The Padding field, if present, shall be at least two octets");
+    m_padding = size;
+}
+
+std::size_t
+CtrlTriggerHeader::GetPaddingSize() const
+{
+    return m_padding;
+}
+
 CtrlTriggerHeader
 CtrlTriggerHeader::GetCommonInfoField() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/ctrl-headers.h ns-3.39/src/wifi/model/ctrl-headers.h
--- ns-3.38/src/wifi/model/ctrl-headers.h	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/ctrl-headers.h	2023-07-05 14:23:48.109428400 -0700
@@ -936,10 +936,7 @@
  *
  * The Padding field is optional, given that other techniques (post-EOF A-MPDU
  * padding, aggregating other MPDUs in the A-MPDU) are available to satisfy the
- * minimum time requirement. Currently, however, a Padding field of the minimum
- * length (2 octets) is appended to every Trigger frame that is transmitted. In
- * such a way, deserialization stops when a User Info field with the AID12 subfield
- * set to 4095 (which indicates the start of a Padding field) is encountered.
+ * minimum time requirement. The size in bytes of the Padding field is configurable.
  */
 class CtrlTriggerHeader : public Header
 {
@@ -1187,6 +1184,17 @@
      */
     uint16_t GetUlSpatialReuse() const;
     /**
+     * Set the size in bytes of the Padding field. The Padding field, if present,
+     * shall be at least two octets in length.
+     *
+     * \param size the size in bytes of the Padding field
+     */
+    void SetPaddingSize(std::size_t size);
+    /**
+     * \return the size in bytes of the Padding field
+     */
+    std::size_t GetPaddingSize() const;
+    /**
      * Get a copy of the Common Info field of this Trigger frame.
      * Note that the User Info fields are excluded.
      *
@@ -1329,6 +1337,7 @@
     uint8_t m_giAndLtfType;         //!< GI And LTF Type subfield
     uint8_t m_apTxPower;            //!< Tx Power used by AP to transmit the Trigger Frame
     uint16_t m_ulSpatialReuse;      //!< Value for the Spatial Reuse field in HE-SIG-A
+    std::size_t m_padding;          //!< the size in bytes of the Padding field
 
     /**
      * List of User Info fields
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/default-emlsr-manager.cc ns-3.39/src/wifi/model/eht/default-emlsr-manager.cc
--- ns-3.38/src/wifi/model/eht/default-emlsr-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/wifi/model/eht/default-emlsr-manager.cc	2023-07-05 14:23:48.109428400 -0700
@@ -0,0 +1,85 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "default-emlsr-manager.h"
+
+#include "ns3/log.h"
+#include "ns3/wifi-mpdu.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("DefaultEmlsrManager");
+
+NS_OBJECT_ENSURE_REGISTERED(DefaultEmlsrManager);
+
+TypeId
+DefaultEmlsrManager::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::DefaultEmlsrManager")
+                            .SetParent<EmlsrManager>()
+                            .SetGroupName("Wifi")
+                            .AddConstructor<DefaultEmlsrManager>();
+    return tid;
+}
+
+DefaultEmlsrManager::DefaultEmlsrManager()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+DefaultEmlsrManager::~DefaultEmlsrManager()
+{
+    NS_LOG_FUNCTION_NOARGS();
+}
+
+void
+DefaultEmlsrManager::DoNotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << *mpdu << linkId);
+
+    if (mpdu->GetHeader().IsAssocResp() && GetStaMac()->IsAssociated() && GetTransitionTimeout())
+    {
+        m_assocLinkId = linkId;
+    }
+}
+
+uint8_t
+DefaultEmlsrManager::GetLinkToSendEmlNotification()
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_assocLinkId, "No recorded link on which Assoc Response was received");
+    return *m_assocLinkId;
+}
+
+std::optional<uint8_t>
+DefaultEmlsrManager::ResendNotification(Ptr<const WifiMpdu> mpdu)
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_assocLinkId, "No recorded link on which Assoc Response was received");
+    return *m_assocLinkId;
+}
+
+void
+DefaultEmlsrManager::NotifyEmlsrModeChanged()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/default-emlsr-manager.h ns-3.39/src/wifi/model/eht/default-emlsr-manager.h
--- ns-3.38/src/wifi/model/eht/default-emlsr-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/wifi/model/eht/default-emlsr-manager.h	2023-07-05 14:23:48.109428400 -0700
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef DEFAULT_EMLSR_MANAGER_H
+#define DEFAULT_EMLSR_MANAGER_H
+
+#include "emlsr-manager.h"
+
+#include <optional>
+
+namespace ns3
+{
+
+/**
+ * \ingroup wifi
+ *
+ * DefaultEmlsrManager is the default EMLSR manager.
+ */
+class DefaultEmlsrManager : public EmlsrManager
+{
+  public:
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    DefaultEmlsrManager();
+    ~DefaultEmlsrManager() override;
+
+  protected:
+    uint8_t GetLinkToSendEmlNotification() override;
+    std::optional<uint8_t> ResendNotification(Ptr<const WifiMpdu> mpdu) override;
+
+  private:
+    void DoNotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
+    void NotifyEmlsrModeChanged() override;
+
+    std::optional<uint8_t> m_assocLinkId; /**< ID of the link on which Association Response
+                                               was received */
+};
+
+} // namespace ns3
+
+#endif /* DEFAULT_EMLSR_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-capabilities.cc ns-3.39/src/wifi/model/eht/eht-capabilities.cc
--- ns-3.38/src/wifi/model/eht/eht-capabilities.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/eht/eht-capabilities.cc	2023-07-05 14:23:48.109428400 -0700
@@ -423,6 +423,12 @@
     return IE_EXT_EHT_CAPABILITIES;
 }
 
+void
+EhtCapabilities::Print(std::ostream& os) const
+{
+    os << "EHT Capabilities="; // TODO
+}
+
 uint16_t
 EhtCapabilities::GetInformationFieldSize() const
 {
@@ -726,11 +732,4 @@
     return count;
 }
 
-std::ostream&
-operator<<(std::ostream& os, const EhtCapabilities& ehtCapabilities)
-{
-    // TODO
-    return os;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-capabilities.h ns-3.39/src/wifi/model/eht/eht-capabilities.h
--- ns-3.38/src/wifi/model/eht/eht-capabilities.h	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/eht/eht-capabilities.h	2023-07-05 14:23:48.109428400 -0700
@@ -261,6 +261,7 @@
     // Implementations of pure virtual methods, or overridden from base class.
     WifiInformationElementId ElementId() const override;
     WifiInformationElementId ElementIdExt() const override;
+    void Print(std::ostream& os) const override;
 
     /**
      * Set the maximum MPDU length.
@@ -347,22 +348,12 @@
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
 
-    friend std::ostream& operator<<(std::ostream& os, const EhtCapabilities& ehtCapabilities);
-
     bool m_is2_4Ghz; //!< flag indicating whether PHY is operating in 2.4 GHz based on other IEs
                      //!< contained in the same management frame
     std::optional<HeCapabilities>
         m_heCapabilities; //!< HE capabilities contained in the same management frame if present
 };
 
-/**
- * output stream output operator
- * \param os the output stream
- * \param ehtCapabilities the EHT capabilities
- * \returns the output stream
- */
-std::ostream& operator<<(std::ostream& os, const EhtCapabilities& ehtCapabilities);
-
 } // namespace ns3
 
 #endif /* EHT_CAPABILITIES_H */
